<form [formGroup]="requestFormGroup" class="request-form" (ngSubmit)="onSubmit()">
  <h1>{{ 'request_for_heads_title' | transloco }}</h1>

  <h2 *ngIf="request?.status">{{request?.status?.status | uppercase}}</h2>

  <fieldset class="request-form__fieldset request-form__center">
    <ng-container *ngIf="requestOperationTypes$ | async; let types">
      <mat-form-field appearance="fill" class="request-form__field">
        <mat-label>{{'about' | transloco | lowercase}}</mat-label>
        <mat-select formControlName="operationTypeId">
          <mat-option *ngFor="let type of types" [value]="type.id">
            {{type.operationType}}
          </mat-option>
        </mat-select>
      </mat-form-field>
      <p>{{'request_for_heads_subtitle' | transloco}}</p>
    </ng-container>
  </fieldset>

  <fieldset class="request-form__fieldset request-form__expert-form-field" formGroupName="expert">
    <p class="label">{{'expert' | transloco}}</p>

    <ng-container *ngIf="(isNewExpert$ | async) || readonly; else expertsDropdown">
      <div class="columns-container">
        <mat-form-field appearance="fill" class="request-form__field">
          <mat-label>{{'last_name' | transloco}}</mat-label>
          <input matInput formControlName="lastName">
        </mat-form-field>

        <mat-form-field appearance="fill" class="request-form__field">
          <mat-label>{{'first_name' | transloco}}</mat-label>
          <input matInput formControlName="firstName">
        </mat-form-field>

        <mat-form-field appearance="fill" class="request-form__field">
          <mat-label>{{'patronymic' | transloco}}</mat-label>
          <input matInput formControlName="patronymic">
        </mat-form-field>
      </div>

      <button mat-raised-button color="accent" type="button" (click)="setFormForExistingExpert()"
        *ngIf="!readonly">
        {{'cancel' | transloco}}
      </button>
    </ng-container>

    <ng-template #expertsDropdown>
      <ng-container *ngIf="experts$ | async; let experts">
        <mat-form-field appearance="fill" class="request-form__field">
          <mat-label>{{'expert' | transloco}}</mat-label>
          <mat-select formControlName="id">
            <mat-option *ngFor="let expert of experts" [value]="expert.id">
              {{expert.lastName}} {{expert.firstName}} {{expert.patronymic}}
            </mat-option>
          </mat-select>
        </mat-form-field>
      </ng-container>

      <ng-container *ngIf="!readonly">
        <p class="label align-self-start">{{'have_not_found_an_expert' | transloco}}</p>

        <button mat-raised-button color="primary" type="button" (click)="setFormForNewExpert()">
          {{'add_new_expert' | transloco}}
        </button>
      </ng-container>
    </ng-template>

  </fieldset>

  <fieldset class="request-form__fieldset" formGroupName="commissionDecision">
    <p class="label">{{'decision_of_central_commission' | transloco}}</p>

    <div class="columns-container">
      <mat-form-field appearance="fill" class="request-form__field">
        <mat-label>{{'number_of_decision' | transloco}}</mat-label>
        <input matInput formControlName="number" type="number">
      </mat-form-field>

      <mat-form-field appearance="fill" class="request-form__field">
        <mat-label>{{'date_of_decision' | transloco}}</mat-label>
        <input matInput formControlName="date" [imask]="dateMask">
      </mat-form-field>

      <ng-container *ngIf="commissionDecisionTypes$ | async; let types">
        <mat-form-field appearance="fill" class="request-form__field">
          <mat-label>{{'type_of_decision' | transloco}}</mat-label>
          <mat-select formControlName="typeId">
            <mat-option *ngFor="let type of types" [value]="type.id">
              {{type.type}}
            </mat-option>
          </mat-select>
        </mat-form-field>
      </ng-container>
    </div>
  </fieldset>

  <fieldset class="request-form__fieldset" formGroupName="certificate">
    <p class="label">{{'certificate' | transloco}}</p>

    <ng-container *ngIf="(isRequestForModification$ | async); else newCertificate">
      <ng-container *ngIf="(expertCertificates$ | async) as certificates; else loader">
        <ng-container *ngIf="certificates.length; else notFound">
          <mat-form-field appearance="fill" class="request-form__field">
            <mat-label>{{'certificate' | transloco}}</mat-label>
            <mat-select formControlName="id">
              <mat-option *ngFor="let certificate of certificates" [value]="certificate.id">
                № {{certificate.documentNumber}}
              </mat-option>
            </mat-select>
          </mat-form-field>
        </ng-container>

        <ng-template #notFound>
          <p>{{'no_certificates_found' | transloco}}</p>
        </ng-template>
      </ng-container>

      <ng-template #loader>
        <app-loader></app-loader>
      </ng-template>
    </ng-container>

    <ng-template #newCertificate>
      <div class="columns-container">
        <mat-form-field appearance="fill" class="request-form__field">
          <mat-label>{{'certificate_number' | transloco}}</mat-label>
          <input matInput formControlName="documentNumber" type="number">
        </mat-form-field>

        <mat-form-field appearance="fill" class="request-form__field">
          <mat-label>{{'certificate_validity_end_date' | transloco}}</mat-label>
          <input matInput formControlName="validityEndDate" [imask]="possiblyFutureDateMask">
        </mat-form-field>
      </div>

      <ng-container *ngIf="expertiseClasses$ | async; let classes">
        <mat-form-field appearance="fill" class="request-form__field">
          <mat-label>{{'expertise_class' | transloco}}</mat-label>
          <mat-select formControlName="expertiseClassId">
            <mat-option *ngFor="let expertiseClass of classes" [value]="expertiseClass.id">
              {{expertiseClass.classNumber}}. {{expertiseClass.name}}
            </mat-option>
          </mat-select>
        </mat-form-field>
      </ng-container>

      <ng-container *ngIf="expertiseTypes$ | async; let types">
        <mat-form-field appearance="fill" class="request-form__field">
          <mat-label>{{'expertise_type' | transloco}}</mat-label>
          <mat-select formControlName="expertiseTypeId">
            <mat-option *ngFor="let type of types" [value]="type.id">
              {{type.number}}. {{type.name}}
            </mat-option>
          </mat-select>
        </mat-form-field>
      </ng-container>

      <mat-form-field appearance="fill" class="request-form__field"
                      *ngIf="(expertiseSpecialities$ | async); let specialities">
        <mat-label>{{'expertise_speciality' | transloco}}</mat-label>
        <mat-select formControlName="expertiseSpecialitiesId" multiple>
          <mat-option *ngFor="let speciality of specialities" [value]="speciality.id">
            {{ speciality.number }}. {{ speciality.name }}
          </mat-option>
        </mat-select>
      </mat-form-field>
    </ng-template>

  </fieldset>

  <fieldset class="request-form__fieldset" formGroupName="commission">
    <p class="label">{{'request_for_experts_commission' | transloco}}</p>

    <div class="columns-container">
      <mat-form-field appearance="fill" class="request-form__field">
        <mat-label>{{'request_for_experts_commission_name' | transloco}}</mat-label>
        <input matInput formControlName="name">
      </mat-form-field>

      <ng-container *ngIf="authorities$ | async; let authorities">
        <mat-form-field appearance="fill" class="request-form__field">
          <mat-label>{{'authority' | transloco}}</mat-label>
          <mat-select formControlName="authorityId">
            <mat-option *ngFor="let authority of authorities" [value]="authority.id">
              {{authority.name}}
            </mat-option>
          </mat-select>
        </mat-form-field>
      </ng-container>
    </div>
  </fieldset>

  <div class="request-form__fieldset" formGroupName="expert">
    <fieldset class="request-form__fieldset" formGroupName="organisation">
      <p class="label">{{'organisation' | transloco}}</p>

      <div class="columns-container">
        <mat-form-field appearance="fill" class="request-form__field">
          <mat-label>{{'name' | transloco}}</mat-label>
          <input matInput formControlName="name">
        </mat-form-field>

        <ng-container *ngIf="regions$ | async; let regions">
          <mat-form-field appearance="fill" class="request-form__field">
            <mat-label>{{'region' | transloco}}</mat-label>
            <mat-select formControlName="regionId">
              <mat-option *ngFor="let region of regions" [value]="region.id">
                {{region.name}}
              </mat-option>
            </mat-select>
          </mat-form-field>
        </ng-container>

        <mat-form-field appearance="fill" class="request-form__field">
          <mat-label>{{'city' | transloco}}</mat-label>
          <input matInput formControlName="city">
        </mat-form-field>

        <mat-form-field appearance="fill" class="request-form__field">
          <mat-label>{{'street' | transloco}}</mat-label>
          <input matInput formControlName="street">
        </mat-form-field>

        <mat-form-field appearance="fill" class="request-form__field">
          <mat-label>{{'number_of_building' | transloco}}</mat-label>
          <input matInput formControlName="numberOfBuilding" type="number">
        </mat-form-field>
      </div>
    </fieldset>

    <fieldset class="request-form__fieldset" formGroupName="contacts">
      <p class="label">{{'contacts' | transloco}}</p>

      <mat-form-field appearance="fill" class="request-form__field">
        <mat-label>{{'phone' | transloco}}</mat-label>
        <input matInput formControlName="phone" [imask]="phoneMask">
      </mat-form-field>

    </fieldset>
  </div>

  <fieldset class="request-form__fieldset" formGroupName="dismissalOrder">
    <p class="label">{{'dismissal_order' | transloco}}</p>

    <div class="columns-container">
      <mat-form-field appearance="fill" class="request-form__field">
        <mat-label>{{'dismissal_order_number' | transloco}}</mat-label>
        <input matInput formControlName="number" type="number">
      </mat-form-field>

      <mat-form-field appearance="fill" class="request-form__field">
        <mat-label>{{'dismissal_order_date' | transloco}}</mat-label>
        <input matInput formControlName="date" [imask]="dateMask">
      </mat-form-field>
    </div>
  </fieldset>

  <div *ngIf="!readonly" class="request-form__submit_container">
    <p class="label" *ngIf="!requestFormGroup.valid">{{'check_entered_values_before_proceeding' | transloco}}</p>

    <button mat-raised-button color="primary" type="submit"
            [disabled]="!requestFormGroup.valid">
      {{'apply' | transloco}}
    </button>
  </div>
</form>

<div *ngIf="request?.comment">
  <h2>{{'comment' | transloco}}</h2>
  <p>{{request?.comment}}</p>
</div>
